/* $Id: ast_variabledeclfragment.h 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_VARIABLEDECLFRAGMENT_H
#define WTPARSER_AST_VARIABLEDECLFRAGMENT_H

#include "../astnode.h"
#include "../uniqueid.h"
#include <string>

namespace wtast
{

class VariableDeclaration;

class VariableDeclFragment : public AstNode
{
	VariableDeclaration* mVarDecl; // parent
	std::string          mName;
	wtparser::UniqueId   mUniqueId;

public:
	VariableDeclFragment(VariableDeclaration* vardecl, const std::string & name, wtparser::UniqueId unique_id)
		: AstNode()
		, mVarDecl(vardecl)
		, mName(name)
		, mUniqueId(unique_id)
	{
		// ok
	}

	~VariableDeclFragment()
	{
		// ok
	}

	void Accept(AstVisitor* vis);

	VariableDeclFragment* Copy();

	Kind GetKind() const
	{
		return VARIABLEDECLFRAGMENT;
	}

	VariableDeclaration* GetVariableDeclaration()
	{
		return mVarDecl;
	}

	std::string & GetName()
	{
		return mName;
	}

	wtparser::UniqueId GetUniqueId()
	{
		return mUniqueId;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_VARIABLEDECLFRAGMENT_H
